Index: trunk/FACT++/gui/FactGui.h
===================================================================
--- trunk/FACT++/gui/FactGui.h	(revision 11753)
+++ trunk/FACT++/gui/FactGui.h	(revision 11759)
@@ -27,4 +27,5 @@
 #include "TGraph.h"
 #include "TH1.h"
+#include "TBox.h"
 #include "TStyle.h"
 #include "TMarker.h"
@@ -346,4 +347,10 @@
         fData = data;
     }
+
+    void SetData(const float *data)
+    {
+        for (int i=0; i<1440; i++)
+            fData[i] = data[i];
+    }
 };
 
@@ -392,4 +399,5 @@
     DimStampedInfo fDimFadRuns;
     DimStampedInfo fDimFadEvents;
+    DimStampedInfo fDimFadRawData;
     DimStampedInfo fDimFadEventData;
     DimStampedInfo fDimFadConnections;
@@ -1138,4 +1146,64 @@
     EVENT *fEventData;
 
+    void DrawHorizontal(TH1 *hf, double xmax, TH1 &h, double scale)
+    {
+        for (Int_t i=1;i<=h.GetNbinsX();i++)
+        {
+            if (h.GetBinContent(i)<0.5 || h.GetBinContent(i)>h.GetEntries()-0.5)
+                continue;
+
+            TBox * box=new TBox(xmax, h.GetBinLowEdge(i),
+                                xmax+h.GetBinContent(i)*scale,
+                                h.GetBinLowEdge(i+1));
+
+            box->SetFillStyle(0);
+            box->SetLineColor(h.GetMarkerColor());
+            box->SetLineStyle(kSolid);
+            box->SetBit(kCannotPick|kNoContextMenu);
+            //box->Draw();
+
+            hf->GetListOfFunctions()->Add(box);
+        }
+    }
+
+    /*
+    void DrawHori(TH1 *h)
+    {
+        //Draw histogram h horizontaly with bars
+        Double_t ymin = h->GetMinimum();
+        Double_t ymax = 1.05*h->GetMaximum();
+
+        TAxis *axis   = ;
+
+        Double_t xmin = h->GetXaxis()->GetXmin();
+        Double_t xmax = h->GetXaxis()->GetXmax();
+
+        Int_t nbins   = h->GetXaxis()->GetNbins();
+
+        //TH2F *h2 = new TH2F("h2",h->GetTitle(),10,ymin,ymax,nbins,xmin,xmax);
+        //h2->SetBit(kCanDelete);
+        //h2->SetDirectory(0);
+        //h2->SetStats(0);
+        //h2->Draw();
+        TBox box;
+        //Int_t color = h->GetFillColor();
+        //if (color == 0) color = 1;
+        box.SetFillColor(color);
+        Double_t dy;
+        Double_t x1,y1,x2,y2;
+        for (Int_t i=1;i<=nbins;i++)
+        {
+            dy = axis->GetBinWidth(i);
+
+            x1 = 0;
+            x2 = h->GetBinContent(i);
+
+            y1 = h->GetBinCenter(i)-0.3*dy;
+            y2 = h->GetBinCenter(i)+0.3*dy;
+
+            box.DrawBox(x1,y1,x2,y2);
+        }
+    }*/
+
     void DisplayEventData()
     {
@@ -1205,5 +1273,5 @@
 	    d2->SetLineColor(kGreen);
 
-            hf->Draw("PL");
+            hf->Draw("");
             d0->Draw("PEX0same");
 	    d1->Draw("PEX0same");
@@ -1214,4 +1282,5 @@
 	}
 
+        // -----------------------------------------------------------
 
         const uint32_t p =
@@ -1232,11 +1301,19 @@
 	hf->SetXTitle(str.str().c_str());
 
+        // -----------------------------------------------------------
+
         const int16_t start = fEventData->StartPix[p];
-        if (start<0)
-        {
+        if (fDrsRuns[0]==0 || start<0)
             d0->Reset();
+        if (fDrsRuns[1]==0 || start<0)
             d1->Reset();
+        if (fDrsRuns[2]==0 || start<0)
             d2->Reset();
-        }
+
+        h->SetEntries(0);
+        d0->SetEntries(0);
+        d1->SetEntries(0);
+        d2->SetEntries(0);
+
         for (int i=0; i<fEventData->Roi; i++)
         {
@@ -1263,4 +1340,6 @@
         }
 
+        // -----------------------------------------------------------
+
         if (fAdcDynamicScale->isChecked())
         {
@@ -1275,11 +1354,11 @@
             if (h->GetMinimumStored()==-1111)
             {
-                h->SetMinimum(-1026);
-                hf->SetMinimum(-1026);
+                h->SetMinimum(-1150);//-1026);
+                hf->SetMinimum(-1150);//-1026);
             }
             if (h->GetMaximumStored()==-1111)
             {
-                h->SetMaximum(1025);
-                hf->SetMaximum(1025);
+                h->SetMaximum(2550);//1025);
+                hf->SetMaximum(2550);//1025);
             }
         }
@@ -1296,4 +1375,56 @@
         }
 
+        // -----------------------------------------------------------
+
+        const int imin = ceil(hf->GetMinimum());
+        const int imax = floor(hf->GetMaximum());
+
+        TH1S hd("", "", imax-imin+1, imin-0.5, imax+0.5);
+        TH1S h0("", "", imax-imin+1, imin-0.5, imax+0.5);
+        TH1S h1("", "", imax-imin+1, imin-0.5, imax+0.5);
+        TH1S h2("", "", imax-imin+1, imin-0.5, imax+0.5);
+        hd.SetDirectory(0);
+        h0.SetDirectory(0);
+        h1.SetDirectory(0);
+        h2.SetDirectory(0);
+
+        for (int i=0; i<fEventData->Roi; i++)
+        {
+            hd.Fill(h->GetBinContent(i+1));
+            h0.Fill(d0->GetBinContent(i+1));
+            h1.Fill(d1->GetBinContent(i+1));
+            h2.Fill(d2->GetBinContent(i+1));
+        }
+
+        double mm = hd.GetMaximum(hd.GetEntries());
+        if (h0.GetMaximum(h0.GetEntries())>mm)
+            mm = h0.GetMaximum();
+        if (h1.GetMaximum(h1.GetEntries())>mm)
+            mm = h1.GetMaximum();
+        if (h2.GetMaximum(h2.GetEntries())>mm)
+            mm = h2.GetMaximum();
+
+        TIter Next(hf->GetListOfFunctions());
+        TObject *obj = 0;
+        while ((obj=Next()))
+            if (dynamic_cast<TBox*>(obj))
+                delete hf->GetListOfFunctions()->Remove(obj);
+
+        const double l = h->GetBinLowEdge(h->GetXaxis()->GetLast()+1);
+        const double m = c->GetX2(); // X2()-X1()
+
+        const double scale = 0.9*(m-l)/mm;
+
+        c->cd();
+
+        DrawHorizontal(hf, l, h2, scale);
+        DrawHorizontal(hf, l, h1, scale);
+        DrawHorizontal(hf, l, h0, scale);
+        DrawHorizontal(hf, l, hd, scale);
+//        DrawHorizontal(hf, l, &h1);
+//        DrawHorizontal(hf, l, &h2);
+
+        // -----------------------------------------------------------
+
 	c->Modified();
 	c->Update();
@@ -1301,5 +1432,5 @@
     }
 
-    void handleFadEventData(const DimData &d)
+    void handleFadRawData(const DimData &d)
     {
 	if (d.size()==0)
@@ -1328,4 +1459,47 @@
 
         DisplayEventData();
+    }
+
+    void handleFadEventData(const DimData &d)
+    {
+        if (!CheckSize(d, 4*1440*sizeof(float)))
+            return;
+
+        static int i=0;
+        if (i++%10>0)
+            return;
+
+        const float *ptr = d.ptr<float>();
+
+        TCanvas *c = fEventCanv->GetCanvas();
+        Camera *cam1 = (Camera*)c->GetPad(1)->FindObject("Camera");
+        Camera *cam2 = (Camera*)c->GetPad(2)->FindObject("Camera");
+        Camera *cam3 = (Camera*)c->GetPad(3)->FindObject("Camera");
+        Camera *cam4 = (Camera*)c->GetPad(4)->FindObject("Camera");
+
+        valarray<double> arr1(1440);
+        valarray<double> arr2(1440);
+        valarray<double> arr3(1440);
+        valarray<double> arr4(1440);
+
+        for (int i=0; i<1440; i++)
+        {
+            arr1[i] = ptr[0*1440+fPixelMapHW[i]];
+            arr2[i] = ptr[1*1440+fPixelMapHW[i]];
+            arr3[i] = ptr[2*1440+fPixelMapHW[i]];
+            arr4[i] = ptr[3*1440+fPixelMapHW[i]];
+        }
+
+        cam1->SetData(arr1);
+        cam2->SetData(arr2);
+        cam3->SetData(arr3);
+        cam4->SetData(arr4);
+
+        c->GetPad(1)->Modified();
+        c->GetPad(2)->Modified();
+//        c->GetPad(3)->Modified();
+//        c->GetPad(4)->Modified();
+
+	c->Update();
     }
 
@@ -1353,4 +1527,6 @@
         fDrsRuns[1] = run[1];
         fDrsRuns[2] = run[2];
+
+        cout << "Received: " << run[0] << " " << run[1] << " " << run[2] << endl;
 
         const float *dat = d.ptr<float>(sizeof(uint32_t)*3);
@@ -2510,5 +2686,8 @@
             return PostInfoHandler(&FactGui::handleFadRuns);
 
-	if (getInfo()==&fDimFadEventData)
+	if (getInfo()==&fDimFadRawData)
+            return PostInfoHandler(&FactGui::handleFadRawData);
+
+        if (getInfo()==&fDimFadEventData)
             return PostInfoHandler(&FactGui::handleFadEventData);
 
@@ -2670,55 +2849,56 @@
         }
 
-        // Find the object which will get picked by the GetObjectInfo
-        // due to buffer overflows in many root-versions
-        // in TH1 and TProfile we have to work around and implement
-        // our own GetObjectInfo which make everything a bit more
-        // complicated.
-        canv->cd();
+        if (obj)
+        {
+            // Find the object which will get picked by the GetObjectInfo
+            // due to buffer overflows in many root-versions
+            // in TH1 and TProfile we have to work around and implement
+            // our own GetObjectInfo which make everything a bit more
+            // complicated.
+            canv->cd();
 #if ROOT_VERSION_CODE > ROOT_VERSION(5,22,00)
-        const char *objectInfo =
-            obj->GetObjectInfo(tipped->GetEventX(),tipped->GetEventY());
+            const char *objectInfo =
+                obj->GetObjectInfo(tipped->GetEventX(),tipped->GetEventY());
 #else
-        const char *objectInfo = dynamic_cast<TH1*>(obj) ?
-            "" : obj->GetObjectInfo(tipped->GetEventX(),tipped->GetEventY());
+            const char *objectInfo = dynamic_cast<TH1*>(obj) ?
+                "" : obj->GetObjectInfo(tipped->GetEventX(),tipped->GetEventY());
 #endif
 
-        QString tipText;
-        tipText += obj->GetName();
-        tipText += " [";
-        tipText += obj->ClassName();
-        tipText += "]: ";
-        tipText += objectInfo;
-
-        if (dynamic_cast<Camera*>(obj))
-        {
-            const float xx = canv->AbsPixeltoX(tipped->GetEventX());
-            const float yy = canv->AbsPixeltoY(tipped->GetEventY());
-
-            Camera *cam = static_cast<Camera*>(obj);
-
-            const int isw = cam->GetIdx(xx, yy);
-            const int ihw = fPixelMapHW[isw];
-
-            const int idx = fPatchHW[isw];
-
-            int ii = 0;
-            for (; ii<160; ii++)
-                if (idx==fPatchMapHW[ii])
-                    break;
-
-
-            const int patch =  ihw%4;
-            const int board = (ihw/4)%10;
-            const int crate = (ihw/4)/10;
-
-            ostringstream str;
-            str << " (hw=" << ihw << ")  Patch=" << ii << "  (hw=" << fPatchMapHW[idx] << "; Crate=" << crate << " Board=" << board << " Patch=" << patch << ")";
-
-            tipText += str.str().c_str();
-        }
-
-
-        fStatusBar->showMessage(tipText, 3000);
+            QString tipText;
+            tipText += obj->GetName();
+            tipText += " [";
+            tipText += obj->ClassName();
+            tipText += "]: ";
+            tipText += objectInfo;
+
+            if (dynamic_cast<Camera*>(obj))
+            {
+                const float xx = canv->AbsPixeltoX(tipped->GetEventX());
+                const float yy = canv->AbsPixeltoY(tipped->GetEventY());
+
+                Camera *cam = static_cast<Camera*>(obj);
+
+                const int isw = cam->GetIdx(xx, yy);
+                const int ihw = fPixelMapHW[isw];
+
+                const int idx = fPatchHW[isw];
+
+                int ii = 0;
+                for (; ii<160; ii++)
+                    if (idx==fPatchMapHW[ii])
+                        break;
+
+
+                const int patch =  ihw%4;
+                const int board = (ihw/4)%10;
+                const int crate = (ihw/4)/10;
+
+                ostringstream str;
+                str << " (hw=" << ihw << ")  Patch=" << ii << "  (hw=" << fPatchMapHW[idx] << "; Crate=" << crate << " Board=" << board << " Patch=" << patch << ")";
+
+                tipText += str.str().c_str();
+            }
+            fStatusBar->showMessage(tipText, 3000);
+        }
 
         gSystem->DispatchOneEvent(kFALSE);
@@ -2959,4 +3139,5 @@
         fDimFadRuns            ("FAD_CONTROL/RUNS",               (void*)NULL, 0, this),
         fDimFadEvents          ("FAD_CONTROL/EVENTS",             (void*)NULL, 0, this),
+        fDimFadRawData         ("FAD_CONTROL/RAW_DATA",           (void*)NULL, 0, this),
         fDimFadEventData       ("FAD_CONTROL/EVENT_DATA",         (void*)NULL, 0, this),
         fDimFadConnections     ("FAD_CONTROL/CONNECTIONS",        (void*)NULL, 0, this),
@@ -3207,6 +3388,46 @@
         c->SetFrameBorderMode(0);
         c->SetFillColor(kWhite);
+        c->SetRightMargin(0.10);
         c->SetGrid();
         c->cd();
+
+        // --------------------------------------------------------------------------
+
+        c = fEventCanv->GetCanvas();
+        c->SetBit(TCanvas::kNoContextMenu);
+        c->SetBorderMode(0);
+        c->SetFrameBorderMode(0);
+        c->SetFillColor(kWhite);
+        c->Divide(2,2);
+        c->cd(1);
+        gPad->SetBorderMode(0);
+        gPad->SetFrameBorderMode(0);
+        gPad->SetFillColor(kWhite);
+        Camera *cam1 = new Camera;
+        cam1->SetBit(kCanDelete);
+        cam1->Draw();
+        c->cd(2);
+        gPad->SetBorderMode(0);
+        gPad->SetFrameBorderMode(0);
+        gPad->SetFillColor(kWhite);
+        Camera *cam2 = new Camera;
+        cam2->SetBit(kCanDelete);
+        cam2->Draw();
+        c->cd(3);
+        gPad->SetBorderMode(0);
+        gPad->SetFrameBorderMode(0);
+        gPad->SetFillColor(kWhite);
+        Camera *cam3 = new Camera;
+        cam3->SetBit(kCanDelete);
+        cam3->Draw();
+        c->cd(4);
+        gPad->SetBorderMode(0);
+        gPad->SetFrameBorderMode(0);
+        gPad->SetFillColor(kWhite);
+        Camera *cam4 = new Camera;
+        cam4->SetBit(kCanDelete);
+        cam4->Draw();
+
+
 
         // Create histogram?
Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 11753)
+++ trunk/FACT++/gui/design.ui	(revision 11759)
@@ -53,5 +53,5 @@
       </property>
       <property name="currentIndex">
-       <number>0</number>
+       <number>6</number>
       </property>
       <property name="documentMode">
@@ -6906,4 +6906,239 @@
        </layout>
       </widget>
+      <widget class="QWidget" name="fEventTab">
+       <attribute name="title">
+        <string>Page</string>
+       </attribute>
+       <layout class="QGridLayout" name="gridLayout_68">
+        <item row="0" column="0">
+         <widget class="QDockWidget" name="fEventDock">
+          <property name="sizePolicy">
+           <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
+            <horstretch>0</horstretch>
+            <verstretch>0</verstretch>
+           </sizepolicy>
+          </property>
+          <property name="features">
+           <set>QDockWidget::NoDockWidgetFeatures</set>
+          </property>
+          <property name="windowTitle">
+           <string>Raw data display</string>
+          </property>
+          <widget class="QWidget" name="fEventWidget">
+           <property name="sizePolicy">
+            <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
+             <horstretch>0</horstretch>
+             <verstretch>0</verstretch>
+            </sizepolicy>
+           </property>
+           <layout class="QGridLayout" name="gridLayout_65">
+            <item row="0" column="0">
+             <widget class="QFrame" name="frame_3">
+              <property name="sizePolicy">
+               <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
+                <horstretch>0</horstretch>
+                <verstretch>0</verstretch>
+               </sizepolicy>
+              </property>
+              <property name="frameShape">
+               <enum>QFrame::StyledPanel</enum>
+              </property>
+              <property name="frameShadow">
+               <enum>QFrame::Sunken</enum>
+              </property>
+              <layout class="QGridLayout" name="gridLayout_67">
+               <property name="margin">
+                <number>3</number>
+               </property>
+               <item row="0" column="0">
+                <widget class="RootWidget" name="fEventCanv" native="true"/>
+               </item>
+              </layout>
+             </widget>
+            </item>
+            <item row="0" column="1">
+             <layout class="QVBoxLayout" name="verticalLayout_10">
+              <property name="rightMargin">
+               <number>0</number>
+              </property>
+              <item>
+               <widget class="QLabel" name="label_176">
+                <property name="text">
+                 <string>Crate</string>
+                </property>
+                <property name="alignment">
+                 <set>Qt::AlignBottom|Qt::AlignLeading|Qt::AlignLeft</set>
+                </property>
+               </widget>
+              </item>
+              <item>
+               <widget class="QSpinBox" name="fAdcCrate_2">
+                <property name="enabled">
+                 <bool>false</bool>
+                </property>
+                <property name="maximum">
+                 <number>3</number>
+                </property>
+               </widget>
+              </item>
+              <item>
+               <widget class="QLabel" name="label_177">
+                <property name="text">
+                 <string>Board</string>
+                </property>
+                <property name="alignment">
+                 <set>Qt::AlignBottom|Qt::AlignLeading|Qt::AlignLeft</set>
+                </property>
+               </widget>
+              </item>
+              <item>
+               <widget class="QSpinBox" name="fAdcBoard_2">
+                <property name="enabled">
+                 <bool>false</bool>
+                </property>
+                <property name="maximum">
+                 <number>9</number>
+                </property>
+               </widget>
+              </item>
+              <item>
+               <widget class="QLabel" name="label_178">
+                <property name="text">
+                 <string>Chip</string>
+                </property>
+                <property name="alignment">
+                 <set>Qt::AlignBottom|Qt::AlignLeading|Qt::AlignLeft</set>
+                </property>
+               </widget>
+              </item>
+              <item>
+               <widget class="QSpinBox" name="fAdcChip_2">
+                <property name="enabled">
+                 <bool>false</bool>
+                </property>
+                <property name="minimum">
+                 <number>0</number>
+                </property>
+                <property name="maximum">
+                 <number>3</number>
+                </property>
+               </widget>
+              </item>
+              <item>
+               <widget class="QLabel" name="label_179">
+                <property name="text">
+                 <string>Channel</string>
+                </property>
+                <property name="alignment">
+                 <set>Qt::AlignBottom|Qt::AlignLeading|Qt::AlignLeft</set>
+                </property>
+               </widget>
+              </item>
+              <item>
+               <widget class="QSpinBox" name="fAdcChannel_2">
+                <property name="enabled">
+                 <bool>false</bool>
+                </property>
+                <property name="maximum">
+                 <number>8</number>
+                </property>
+               </widget>
+              </item>
+              <item>
+               <spacer name="verticalSpacer_52">
+                <property name="orientation">
+                 <enum>Qt::Vertical</enum>
+                </property>
+                <property name="sizeType">
+                 <enum>QSizePolicy::Fixed</enum>
+                </property>
+                <property name="sizeHint" stdset="0">
+                 <size>
+                  <width>20</width>
+                  <height>20</height>
+                 </size>
+                </property>
+               </spacer>
+              </item>
+              <item>
+               <widget class="QCheckBox" name="fAdcStop_2">
+                <property name="enabled">
+                 <bool>false</bool>
+                </property>
+                <property name="text">
+                 <string>Stop</string>
+                </property>
+               </widget>
+              </item>
+              <item>
+               <spacer name="verticalSpacer_53">
+                <property name="orientation">
+                 <enum>Qt::Vertical</enum>
+                </property>
+                <property name="sizeType">
+                 <enum>QSizePolicy::Fixed</enum>
+                </property>
+                <property name="sizeHint" stdset="0">
+                 <size>
+                  <width>20</width>
+                  <height>10</height>
+                 </size>
+                </property>
+               </spacer>
+              </item>
+              <item>
+               <widget class="QRadioButton" name="fAdcManualScale_2">
+                <property name="enabled">
+                 <bool>false</bool>
+                </property>
+                <property name="text">
+                 <string>Manual scale</string>
+                </property>
+                <property name="checked">
+                 <bool>true</bool>
+                </property>
+               </widget>
+              </item>
+              <item>
+               <widget class="QRadioButton" name="fAdcDynamicScale_2">
+                <property name="enabled">
+                 <bool>false</bool>
+                </property>
+                <property name="text">
+                 <string>Dynamic scale</string>
+                </property>
+               </widget>
+              </item>
+              <item>
+               <widget class="QRadioButton" name="fAdcAutoScale_2">
+                <property name="enabled">
+                 <bool>false</bool>
+                </property>
+                <property name="text">
+                 <string>Auto min/max</string>
+                </property>
+               </widget>
+              </item>
+              <item>
+               <spacer name="verticalSpacer_54">
+                <property name="orientation">
+                 <enum>Qt::Vertical</enum>
+                </property>
+                <property name="sizeHint" stdset="0">
+                 <size>
+                  <width>20</width>
+                  <height>40</height>
+                 </size>
+                </property>
+               </spacer>
+              </item>
+             </layout>
+            </item>
+           </layout>
+          </widget>
+         </widget>
+        </item>
+       </layout>
+      </widget>
       <widget class="QWidget" name="fLoggerTab">
        <property name="enabled">
@@ -7254,16 +7489,4 @@
                <enum>QAbstractSpinBox::NoButtons</enum>
               </property>
-              <property name="currentSection">
-               <enum>QDateTimeEdit::HourSection</enum>
-              </property>
-              <property name="displayFormat">
-               <string>hh:mm:ss</string>
-              </property>
-              <property name="calendarPopup">
-               <bool>false</bool>
-              </property>
-              <property name="timeSpec">
-               <enum>Qt::OffsetFromUTC</enum>
-              </property>
               <property name="time">
                <time>
@@ -7272,4 +7495,16 @@
                 <second>0</second>
                </time>
+              </property>
+              <property name="currentSection">
+               <enum>QDateTimeEdit::HourSection</enum>
+              </property>
+              <property name="displayFormat">
+               <string>hh:mm:ss</string>
+              </property>
+              <property name="calendarPopup">
+               <bool>false</bool>
+              </property>
+              <property name="timeSpec">
+               <enum>Qt::OffsetFromUTC</enum>
               </property>
              </widget>
@@ -7396,16 +7631,4 @@
                <enum>QAbstractSpinBox::NoButtons</enum>
               </property>
-              <property name="currentSection">
-               <enum>QDateTimeEdit::HourSection</enum>
-              </property>
-              <property name="displayFormat">
-               <string>hh:mm:ss</string>
-              </property>
-              <property name="calendarPopup">
-               <bool>false</bool>
-              </property>
-              <property name="timeSpec">
-               <enum>Qt::OffsetFromUTC</enum>
-              </property>
               <property name="time">
                <time>
@@ -7414,4 +7637,16 @@
                 <second>0</second>
                </time>
+              </property>
+              <property name="currentSection">
+               <enum>QDateTimeEdit::HourSection</enum>
+              </property>
+              <property name="displayFormat">
+               <string>hh:mm:ss</string>
+              </property>
+              <property name="calendarPopup">
+               <bool>false</bool>
+              </property>
+              <property name="timeSpec">
+               <enum>Qt::OffsetFromUTC</enum>
               </property>
              </widget>