Index: trunk/FACT++/configure
===================================================================
--- trunk/FACT++/configure	(revision 11721)
+++ trunk/FACT++/configure	(revision 11808)
@@ -761,8 +761,4 @@
 HAS_GL_FALSE
 HAS_GL_TRUE
-HAS_FITS_H_FALSE
-HAS_FITS_H_TRUE
-HAS_IZSTREAM_H_FALSE
-HAS_IZSTREAM_H_TRUE
 HAS_ZLIB_FALSE
 HAS_ZLIB_TRUE
@@ -4846,11 +4842,11 @@
   lt_cv_nm_interface="BSD nm"
   echo "int some_variable = 0;" > conftest.$ac_ext
-  (eval echo "\"\$as_me:4848: $ac_compile\"" >&5)
+  (eval echo "\"\$as_me:4844: $ac_compile\"" >&5)
   (eval "$ac_compile" 2>conftest.err)
   cat conftest.err >&5
-  (eval echo "\"\$as_me:4851: $NM \\\"conftest.$ac_objext\\\"\"" >&5)
+  (eval echo "\"\$as_me:4847: $NM \\\"conftest.$ac_objext\\\"\"" >&5)
   (eval "$NM \"conftest.$ac_objext\"" 2>conftest.err > conftest.out)
   cat conftest.err >&5
-  (eval echo "\"\$as_me:4854: output\"" >&5)
+  (eval echo "\"\$as_me:4850: output\"" >&5)
   cat conftest.out >&5
   if $GREP 'External.*some_variable' conftest.out > /dev/null; then
@@ -6057,5 +6053,5 @@
 *-*-irix6*)
   # Find out which ABI we are using.
-  echo '#line 6059 "configure"' > conftest.$ac_ext
+  echo '#line 6055 "configure"' > conftest.$ac_ext
   if { { eval echo "\"\$as_me\":${as_lineno-$LINENO}: \"$ac_compile\""; } >&5
   (eval $ac_compile) 2>&5
@@ -7718,9 +7714,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:7720: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:7716: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:7724: \$? = $ac_status" >&5
+   echo "$as_me:7720: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
@@ -8057,9 +8053,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8059: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8055: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:8063: \$? = $ac_status" >&5
+   echo "$as_me:8059: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
@@ -8162,9 +8158,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8164: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8160: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:8168: \$? = $ac_status" >&5
+   echo "$as_me:8164: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -8217,9 +8213,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8219: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8215: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:8223: \$? = $ac_status" >&5
+   echo "$as_me:8219: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -10601,5 +10597,5 @@
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<_LT_EOF
-#line 10603 "configure"
+#line 10599 "configure"
 #include "confdefs.h"
 
@@ -10697,5 +10693,5 @@
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<_LT_EOF
-#line 10699 "configure"
+#line 10695 "configure"
 #include "confdefs.h"
 
@@ -12653,9 +12649,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:12655: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:12651: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:12659: \$? = $ac_status" >&5
+   echo "$as_me:12655: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
@@ -12752,9 +12748,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:12754: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:12750: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:12758: \$? = $ac_status" >&5
+   echo "$as_me:12754: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -12804,9 +12800,9 @@
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:12806: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:12802: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:12810: \$? = $ac_status" >&5
+   echo "$as_me:12806: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
@@ -18308,8 +18304,4 @@
 	fi
 
-        { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: ${LANGUAGE}" >&5
-$as_echo "$as_me: WARNING: ${LANGUAGE}" >&2;}
-
-
 	ac_fn_c_check_header_mongrel "$LINENO" "zlib.h" "ac_cv_header_zlib_h" "$ac_includes_default"
 if test "x$ac_cv_header_zlib_h" = x""yes; then :
@@ -18428,8 +18420,4 @@
 	fi
 
-        { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: ${LANGUAGE}" >&5
-$as_echo "$as_me: WARNING: ${LANGUAGE}" >&2;}
-
-
 	ac_fn_c_check_header_mongrel "$LINENO" "GL/gl.h" "ac_cv_header_GL_gl_h" "$ac_includes_default"
 if test "x$ac_cv_header_GL_gl_h" = x""yes; then :
@@ -18546,8 +18534,4 @@
 	fi
 
-        { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: ${LANGUAGE}" >&5
-$as_echo "$as_me: WARNING: ${LANGUAGE}" >&2;}
-
-
 	ac_fn_c_check_header_mongrel "$LINENO" "GL/glu.h" "ac_cv_header_GL_glu_h" "$ac_includes_default"
 if test "x$ac_cv_header_GL_glu_h" = x""yes; then :
@@ -18629,46 +18613,8 @@
 
 # Check for the fits header and zstream support from MARS
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for gui/RawEventsViewer/izstream.h" >&5
-$as_echo_n "checking for gui/RawEventsViewer/izstream.h... " >&6; }
-if test "${ac_cv_file_gui_RawEventsViewer_izstream_h+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  test "$cross_compiling" = yes &&
-  as_fn_error $? "cannot check for file existence when cross compiling" "$LINENO" 5
-if test -r "gui/RawEventsViewer/izstream.h"; then
-  ac_cv_file_gui_RawEventsViewer_izstream_h=yes
-else
-  ac_cv_file_gui_RawEventsViewer_izstream_h=no
-fi
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_file_gui_RawEventsViewer_izstream_h" >&5
-$as_echo "$ac_cv_file_gui_RawEventsViewer_izstream_h" >&6; }
-if test "x$ac_cv_file_gui_RawEventsViewer_izstream_h" = x""yes; then :
-  HAVE_IZSTREAM_H=yes
-else
-  HAVE_IZSTREAM_H=no
-fi
-
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for gui/RawEventsViewer/fits.h" >&5
-$as_echo_n "checking for gui/RawEventsViewer/fits.h... " >&6; }
-if test "${ac_cv_file_gui_RawEventsViewer_fits_h+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  test "$cross_compiling" = yes &&
-  as_fn_error $? "cannot check for file existence when cross compiling" "$LINENO" 5
-if test -r "gui/RawEventsViewer/fits.h"; then
-  ac_cv_file_gui_RawEventsViewer_fits_h=yes
-else
-  ac_cv_file_gui_RawEventsViewer_fits_h=no
-fi
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_file_gui_RawEventsViewer_fits_h" >&5
-$as_echo "$ac_cv_file_gui_RawEventsViewer_fits_h" >&6; }
-if test "x$ac_cv_file_gui_RawEventsViewer_fits_h" = x""yes; then :
-  HAVE_FITS_H=yes
-else
-  HAVE_FITS_H=no
-fi
-
+#AC_CHECK_FILE(gui/RawEventsViewer/izstream.h,
+#		HAVE_IZSTREAM_H=yes, HAVE_IZSTREAM_H=no)
+#AC_CHECK_FILE(gui/RawEventsViewer/fits.h,
+#		HAVE_FITS_H=yes, HAVE_FITS_H=no)
 
 # Needed to compile FACT++
@@ -18714,8 +18660,4 @@
 		CFLAGS="$CFLAGS -I${cfitsio_include}"
 	fi
-
-        { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: ${LANGUAGE}" >&5
-$as_echo "$as_me: WARNING: ${LANGUAGE}" >&2;}
-
 
 	ac_fn_c_check_header_mongrel "$LINENO" "fitsio.h" "ac_cv_header_fitsio_h" "$ac_includes_default"
@@ -18845,8 +18787,4 @@
 		CFLAGS="$CFLAGS -I${ccfits_include}"
 	fi
-
-        { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: ${LANGUAGE}" >&5
-$as_echo "$as_me: WARNING: ${LANGUAGE}" >&2;}
-
 
 	ac_fn_cxx_check_header_mongrel "$LINENO" "CCfits/CCfits" "ac_cv_header_CCfits_CCfits" "$ac_includes_default"
@@ -22152,5 +22090,5 @@
 
 		cat > conftest.$ac_ext <<EOF
-#line 22154 "configure"
+#line 22092 "configure"
 #include "confdefs.h"
 #include <qglobal.h>
@@ -23130,20 +23068,6 @@
 fi
 
- if test "$HAVE_IZSTREAM_H" = yes; then
-  HAS_IZSTREAM_H_TRUE=
-  HAS_IZSTREAM_H_FALSE='#'
-else
-  HAS_IZSTREAM_H_TRUE='#'
-  HAS_IZSTREAM_H_FALSE=
-fi
-
- if test "$HAVE_FITS_H" = yes; then
-  HAS_FITS_H_TRUE=
-  HAS_FITS_H_FALSE='#'
-else
-  HAS_FITS_H_TRUE='#'
-  HAS_FITS_H_FALSE=
-fi
-
+#AM_CONDITIONAL(HAS_IZSTREAM_H,[test "$HAVE_IZSTREAM_H" = yes])
+#AM_CONDITIONAL(HAS_FITS_H,    [test "$HAVE_FITS_H" = yes])
  if test "$HAVE_GL" = yes; then
   HAS_GL_TRUE=
@@ -23179,5 +23103,5 @@
 
 
- if test "$QT4_VERSION" -a "$HAVE_FITS_H" = yes -a "$HAVE_GL" = yes -a "$HAVE_GLU" = yes -a "$HAVE_QGL" = yes -a "$HAVE_QWT" = yes; then
+ if test "$QT4_VERSION" -a "$HAVE_GL" = yes -a "$HAVE_GLU" = yes -a "$HAVE_QGL" = yes -a "$HAVE_QWT" = yes; then
   HAS_VIEWER_TRUE=
   HAS_VIEWER_FALSE='#'
@@ -23213,17 +23137,13 @@
 
 fi
-
-if test "$HAVE_FITS_H" = yes; then
-
-   if test "$HAVE_IZSTREAM_H" = yes; then
-
-      if test "$HAVE_ZLIB" = yes; then
+if test "$HAVE_ZLIB" = yes; then
   $as_echo "#define HAVE_ZLIB 1" >>confdefs.h
 
 fi
 
-fi
-
-fi
+#AM_COND_IF(HAS_FITS_H, [
+#   AM_COND_IF(HAS_IZSTREAM_H, [
+#   ])
+#],)
 
 
@@ -23540,12 +23460,4 @@
 if test -z "${HAS_ZLIB_TRUE}" && test -z "${HAS_ZLIB_FALSE}"; then
   as_fn_error $? "conditional \"HAS_ZLIB\" was never defined.
-Usually this means the macro was only invoked conditionally." "$LINENO" 5
-fi
-if test -z "${HAS_IZSTREAM_H_TRUE}" && test -z "${HAS_IZSTREAM_H_FALSE}"; then
-  as_fn_error $? "conditional \"HAS_IZSTREAM_H\" was never defined.
-Usually this means the macro was only invoked conditionally." "$LINENO" 5
-fi
-if test -z "${HAS_FITS_H_TRUE}" && test -z "${HAS_FITS_H_FALSE}"; then
-  as_fn_error $? "conditional \"HAS_FITS_H\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
@@ -25960,8 +25872,6 @@
 { $as_echo "$as_me:${as_lineno-$LINENO}:  zlib                   / 'zlib.h'           found: $HAVE_ZLIB" >&5
 $as_echo "$as_me:  zlib                   / 'zlib.h'           found: $HAVE_ZLIB" >&6;}
-{ $as_echo "$as_me:${as_lineno-$LINENO}:  gui/RawEventsViewer/izstream.h              found: $HAVE_IZSTREAM_H" >&5
-$as_echo "$as_me:  gui/RawEventsViewer/izstream.h              found: $HAVE_IZSTREAM_H" >&6;}
-{ $as_echo "$as_me:${as_lineno-$LINENO}:  gui/RawEventsViewer/fits.h                  found: $HAVE_FITS_H" >&5
-$as_echo "$as_me:  gui/RawEventsViewer/fits.h                  found: $HAVE_FITS_H" >&6;}
+#AC_MSG_NOTICE([ gui/RawEventsViewer/izstream.h              found: $HAVE_IZSTREAM_H])
+#AC_MSG_NOTICE([ gui/RawEventsViewer/fits.h                  found: $HAVE_FITS_H])
 { $as_echo "$as_me:${as_lineno-$LINENO}:  GL                     / GL/gl.h            found: $HAVE_GL" >&5
 $as_echo "$as_me:  GL                     / GL/gl.h            found: $HAVE_GL" >&6;}
@@ -26132,26 +26042,18 @@
 { $as_echo "$as_me:${as_lineno-$LINENO}: " >&5
 $as_echo "$as_me: " >&6;}
-if test "$HAVE_FITS_H" = yes; then
-
+#AM_COND_IF(HAS_FITS_H, [
    if test "$HAVE_ZLIB" = yes; then
   :
 else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  zlib not found. Support for .fits.gz in viewer disabled." >&5
-$as_echo "$as_me: WARNING:  zlib not found. Support for .fits.gz in viewer disabled." >&2;}
-
-fi
-   if test "$HAVE_IZSTREAM_H" = yes; then
-  :
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  Mars izstream.h not found in gui/RawEventsViewer. Support for .fits.gz disabled." >&5
-$as_echo "$as_me: WARNING:  Mars izstream.h not found in gui/RawEventsViewer. Support for .fits.gz disabled." >&2;}
-
-fi
-
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  Mars fits.h not found in gui/RawEventsViewer. Target 'viewer' disabled." >&5
-$as_echo "$as_me: WARNING:  Mars fits.h not found in gui/RawEventsViewer. Target 'viewer' disabled." >&2;}
-
-fi
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  zlib not found. Support for reading .fits.gz disabled." >&5
+$as_echo "$as_me: WARNING:  zlib not found. Support for reading .fits.gz disabled." >&2;}
+
+fi
+#   AM_COND_IF(HAS_IZSTREAM_H,,
+#      AC_MSG_WARN([ Mars izstream.h not found in gui/RawEventsViewer. Support for .fits.gz disabled.])
+#   )
+#],
+#   AC_MSG_WARN([ Mars fits.h not found in gui/RawEventsViewer. Target 'viewer' disabled.])
+#)
 if test "$lt_cv_libxp" = "yes"; then
   :
@@ -26190,4 +26092,10 @@
 $as_echo "$as_me: WARNING:  GLU not found - viewer will be disabled." >&2;}
 fi
+if test "$HAVE_QWT" = yes; then
+  :
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  Qwt not found - viewer will be disabled." >&5
+$as_echo "$as_me: WARNING:  Qwt not found - viewer will be disabled." >&2;}
+fi
 
 if test -n "$QT4_VERSION"; then