Index: trunk/FACT++/configure
===================================================================
--- trunk/FACT++/configure	(revision 11808)
+++ trunk/FACT++/configure	(revision 11822)
@@ -753,4 +753,6 @@
 HAS_VIEWER_FALSE
 HAS_VIEWER_TRUE
+HAS_GUI_FALSE
+HAS_GUI_TRUE
 HAS_QWT_FALSE
 HAS_QWT_TRUE
@@ -769,6 +771,4 @@
 HAS_CFITSIO_FALSE
 HAS_CFITSIO_TRUE
-HAS_GUI_FALSE
-HAS_GUI_TRUE
 HAS_ROOT_QT_FALSE
 HAS_ROOT_QT_TRUE
@@ -23028,12 +23028,4 @@
 fi
 
- if test "$QT4_VERSION" -a "$HAVE_ROOT_QT" = yes; then
-  HAS_GUI_TRUE=
-  HAS_GUI_FALSE='#'
-else
-  HAS_GUI_TRUE='#'
-  HAS_GUI_FALSE=
-fi
-
  if test "$HAVE_CFITSIO" = yes; then
   HAS_CFITSIO_TRUE=
@@ -23102,4 +23094,12 @@
 fi
 
+
+ if test "$QT4_VERSION" -a "$HAVE_GL" = yes -a "$HAVE_GLU" = yes -a "$HAVE_QGL" = yes -a "$HAVE_ROOT_QT" = yes ; then
+  HAS_GUI_TRUE=
+  HAS_GUI_FALSE='#'
+else
+  HAS_GUI_TRUE='#'
+  HAS_GUI_FALSE=
+fi
 
  if test "$QT4_VERSION" -a "$HAVE_GL" = yes -a "$HAVE_GLU" = yes -a "$HAVE_QGL" = yes -a "$HAVE_QWT" = yes; then
@@ -23442,8 +23442,4 @@
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
-if test -z "${HAS_GUI_TRUE}" && test -z "${HAS_GUI_FALSE}"; then
-  as_fn_error $? "conditional \"HAS_GUI\" was never defined.
-Usually this means the macro was only invoked conditionally." "$LINENO" 5
-fi
 if test -z "${HAS_CFITSIO_TRUE}" && test -z "${HAS_CFITSIO_FALSE}"; then
   as_fn_error $? "conditional \"HAS_CFITSIO\" was never defined.
@@ -23476,4 +23472,8 @@
 if test -z "${HAS_QWT_TRUE}" && test -z "${HAS_QWT_FALSE}"; then
   as_fn_error $? "conditional \"HAS_QWT\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${HAS_GUI_TRUE}" && test -z "${HAS_GUI_FALSE}"; then
+  as_fn_error $? "conditional \"HAS_GUI\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
@@ -26042,6 +26042,5 @@
 { $as_echo "$as_me:${as_lineno-$LINENO}: " >&5
 $as_echo "$as_me: " >&6;}
-#AM_COND_IF(HAS_FITS_H, [
-   if test "$HAVE_ZLIB" = yes; then
+if test "$HAVE_ZLIB" = yes; then
   :
 else
@@ -26050,10 +26049,4 @@
 
 fi
-#   AM_COND_IF(HAS_IZSTREAM_H,,
-#      AC_MSG_WARN([ Mars izstream.h not found in gui/RawEventsViewer. Support for .fits.gz disabled.])
-#   )
-#],
-#   AC_MSG_WARN([ Mars fits.h not found in gui/RawEventsViewer. Target 'viewer' disabled.])
-#)
 if test "$lt_cv_libxp" = "yes"; then
   :
@@ -26080,15 +26073,27 @@
 
 fi
+if test -n "$QT4_VERSION"; then
+  :
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  QT4 missing - GUIs disabled!" >&5
+$as_echo "$as_me: WARNING:  QT4 missing - GUIs disabled!" >&2;}
+fi
 if test "$HAVE_GL" = yes; then
   :
 else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  GL not found - viewer will be disabled." >&5
-$as_echo "$as_me: WARNING:  GL not found - viewer will be disabled." >&2;}
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  GL not found - GUIs will be disabled." >&5
+$as_echo "$as_me: WARNING:  GL not found - GUIs will be disabled." >&2;}
 fi
 if test "$HAVE_GLU" = yes; then
   :
 else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  GLU not found - viewer will be disabled." >&5
-$as_echo "$as_me: WARNING:  GLU not found - viewer will be disabled." >&2;}
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  GLU not found - GUIs will be disabled." >&5
+$as_echo "$as_me: WARNING:  GLU not found - GUIs will be disabled." >&2;}
+fi
+if test "$HAVE_QGL" = yes; then
+  :
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  QtOpenGl not found - GUIs will be disabled." >&5
+$as_echo "$as_me: WARNING:  QtOpenGl not found - GUIs will be disabled." >&2;}
 fi
 if test "$HAVE_QWT" = yes; then
@@ -26098,17 +26103,16 @@
 $as_echo "$as_me: WARNING:  Qwt not found - viewer will be disabled." >&2;}
 fi
-
-if test -n "$QT4_VERSION"; then
+if test "$QT4_VERSION" -a "$HAVE_GL" = yes -a "$HAVE_GLU" = yes -a "$HAVE_QGL" = yes -a "$HAVE_ROOT_QT" = yes ; then
   :
 else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  QT4 missing: fact and viewer GUI disabled!" >&5
-$as_echo "$as_me: WARNING:  QT4 missing: fact and viewer GUI disabled!" >&2;}
-
-fi
-if test "$QT4_VERSION" -a "$HAVE_ROOT_QT" = yes; then
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  Either of the necessary packages not found - fact GUI disabled!" >&5
+$as_echo "$as_me: WARNING:  Either of the necessary packages not found - fact GUI disabled!" >&2;}
+
+fi
+if test "$QT4_VERSION" -a "$HAVE_GL" = yes -a "$HAVE_GLU" = yes -a "$HAVE_QGL" = yes -a "$HAVE_QWT" = yes; then
   :
 else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  Either QT4 or qt-root is missing: fact GUI disabled!" >&5
-$as_echo "$as_me: WARNING:  Either QT4 or qt-root is missing: fact GUI disabled!" >&2;}
+  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING:  Either of the necessary packages not found - viewer GUI disabled!" >&5
+$as_echo "$as_me: WARNING:  Either of the necessary packages not found - viewer GUI disabled!" >&2;}
 
 fi